<?php

namespace App\Model;

use App\Controller\AuthController;
use App\Gateway\AuthGateway;
use App\Validation\FieldValidationFail;

class AuthModel {


    private AuthGateway $gateway;
    /**
     * @param AuthGateway $gateway
     */
    public function __construct(AuthGateway $gateway) {
        $this->gateway = $gateway;
    }


    public function validationRegister(string $username, string $password, string $confirmPassword,string $email): array {
        $errors = [];
        if ($password != $confirmPassword) {
            $errors[] = new FieldValidationFail("confirmpassword","passwords not equals");
        }

        if ($this->gateway->mailExist($email)){
            $errors[] = new FieldValidationFail("email","email already exist");
        }

        if(empty($errors)){
            $hash = password_hash($password,PASSWORD_DEFAULT);
            $this->gateway->insertAccount($username,$hash,$email);
        }

        return $errors;
    }

    public function getUserFields(string $email):array{
        return $this->gateway->getUserFields($email);
    }



}